﻿<AML>
 <Item type="Method" id="199C9EFEAA5C4DC8821CD031520F668A" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Method Name:			pop_po_disable_tabs
Created By		:		SolidCAD 
Creation Date:			2018-01-23
Description:
	When classification is "EQUIPMENT",
	    -Clear previous relationships data initially and relationship tab refresh.
	    -Hide Service Detail and Service Part Detail.
	When classification is "SERVICE",
	    -Clear previous relationships data initially and relationship tab refresh.
	    -Hide Stock Detail.
	
Hooks:
	Type:	Form	:	sop_po_out
	Event:	classification ( onChange )
	
	Type:	Form	:	sop_po_out
	Event:	Form Event ( onFormPopulated )

Revisions:
	Rev Date		Modified By			Description
	YYYY-MM-DD		$username$			Initial creation
***************************************************************************** */
//debugger;
var myInnovator = new Innovator();
var tabbar;
var desiredTabId;
var fRelationships;
var gRelationships;
var itemCount;
var item;
var i;
var iFramesCollection;
var tabId;
var relshipTypeNd;
var relshipTypeName;
var _this_item = document.thisItem;
var _id = _this_item.getID();
var sop_po_out;
var result;
var result_count;
var classificationcode;
//Check if relationship grid is loaded
//Function to hide tabs
hideTabs = function() {

    if (!isTabbarReady()) {
        setTimeout(hideTabs, 10);
        return;
    }

    tabbar = parent.relationships.relTabbar;
    var classification = document.thisItem.getProperty('classification');
    var sop_order_no = document.thisItem.getProperty('sop_order_no');
    sop_po_out = myInnovator.newItem("sop_po_out", "get");
    sop_po_out.setProperty("id", _id);
    sop_po_out.setPropertyCondition("id", "eq");
    result = sop_po_out.apply();
    result_count = result.getItemCount();
    if (result_count > 0) {
        var result_data = result.getItemByIndex(0);
        classificationcode = result_data.getProperty("classification");
    }
    if (classification === "EQUIPMENT") {
        if (result_count <= 0) {
            /** clear previous relationships data initially and relationship tab refresh**/

            fRelationships = _this_item.fetchRelationships("sop_po_service_details");
            gRelationships = _this_item.getRelationships("sop_po_service_details");
            itemCount = gRelationships.getItemCount();

            for (i = 0; i < itemCount; i++) {
                item = gRelationships.getItemByIndex(i);
                _this_item.removeRelationship(item);
            }

            fRelationships = _this_item.fetchRelationships("sop_po_service_part_details");
            gRelationships = _this_item.getRelationships("sop_po_service_part_details");
            itemCount = gRelationships.getItemCount();

            for (i = 0; i < itemCount; i++) {
                item = gRelationships.getItemByIndex(i);
                _this_item.removeRelationship(item);
            }
            if (sop_order_no === null || sop_order_no === undefined || sop_order_no === "") {
                handleItemChange("pop_sub_amount", "0.00");
                handleItemChange("pop_gst_amount", "0.00");
                handleItemChange("pop_total_amount", "0.00");
                handleItemChange("pop_hide_sub_total", "0.00");
                handleItemChange("pop_lumpsum_discount", "0.00");
            }

            if (aras.getMostTopWindowWithAras(window).frames.relationships) { // check "no tabs in tab view" 
                iFramesCollection = aras.getMostTopWindowWithAras(window).frames.relationships.iframesCollection;
                for (tabId in iFramesCollection) {
                    relshipTypeNd = aras.getRelationshipType(tabId);
                    relshipTypeName = aras.getItemProperty(relshipTypeNd.node, "name");
                    if (relshipTypeName === "sop_po_service_part_details") {
                        iFramesCollection[tabId].contentWindow.location.reload();
                    }
                }
            }
            /** clear previous relationships data initially and relationship tab refresh **/
        }
    }
    if (classification === "SERVICE") {

        if (result_count <= 0) {
            /** clear previous relationships data initially and relationship tab refresh **/

            fRelationships = _this_item.fetchRelationships("sop_po_out_details");
            gRelationships = _this_item.getRelationships("sop_po_out_details");
            itemCount = gRelationships.getItemCount();

            for (i = 0; i < itemCount; i++) {
                item = gRelationships.getItemByIndex(i);
                _this_item.removeRelationship(item);
            }

            if (sop_order_no === null || sop_order_no === undefined || sop_order_no === "") {
                handleItemChange("pop_sub_amount", "0.00");
                handleItemChange("pop_gst_amount", "0.00");
                handleItemChange("pop_total_amount", "0.00");
                handleItemChange("pop_hide_sub_total", "0.00");
                handleItemChange("pop_lumpsum_discount", "0.00");
            }

            if (aras.getMostTopWindowWithAras(window).frames.relationships) { // check "no tabs in tab view" 
                iFramesCollection = aras.getMostTopWindowWithAras(window).frames.relationships.iframesCollection;
                for (tabId in iFramesCollection) {
                    relshipTypeNd = aras.getRelationshipType(tabId);
                    relshipTypeName = aras.getItemProperty(relshipTypeNd.node, "name");
                    if (relshipTypeName === "sop_po_out_details") {
                        iFramesCollection[tabId].contentWindow.location.reload();
                    }
                }
            }
        /** clear previous relationships data initially and relationship tab refresh **/

        }
    }
    if (classification === "EQUIPMENT") {
        /**Always show classification="EQUIPMENT" For editing Item**/
        if (classificationcode === "SERVICE") {
            handleItemChange("classification", "SERVICE");
            // Disable Tabs
            //equipment 
            tabbar.SetTabEnabled("61FF5BA710F14765A90E04EB2EDD334D", false);

            // service 
            tabbar.SetTabEnabled("4C1643C3D7EC48CFADB45A87CE64BCD4", true);
            tabbar.SetTabEnabled("1F4AC872C5DD48258928E0C2CD50F9E4", true);

            desiredTabId = "4C1643C3D7EC48CFADB45A87CE64BCD4";
            tabbar.selectTab(desiredTabId);
        }
        /**Always show classification="EQUIPMENT" For editing Item**/
        else {
            //equipment 
            tabbar.SetTabEnabled("61FF5BA710F14765A90E04EB2EDD334D", true);

            // service 
            tabbar.SetTabEnabled("4C1643C3D7EC48CFADB45A87CE64BCD4", false);
            tabbar.SetTabEnabled("1F4AC872C5DD48258928E0C2CD50F9E4", false);

            desiredTabId = "61FF5BA710F14765A90E04EB2EDD334D";
            tabbar.selectTab(desiredTabId);
        }


    }

    if (classification === "SERVICE") {

        // Disable Tabs
        //equipment 
        tabbar.SetTabEnabled("61FF5BA710F14765A90E04EB2EDD334D", false);

        // service 
        tabbar.SetTabEnabled("4C1643C3D7EC48CFADB45A87CE64BCD4", true);
        tabbar.SetTabEnabled("1F4AC872C5DD48258928E0C2CD50F9E4", true);

        desiredTabId = "4C1643C3D7EC48CFADB45A87CE64BCD4";
        tabbar.selectTab(desiredTabId);
    }

    parent.relationshipsControl.onloaded();
};



//Function to check if relationship grid is loaded
var isTabbarReady = function() {

    if (parent.relationships === undefined)
        return false;

    var isReady = Boolean(!parent.relationships ||
        !parent.relationships.relTabbarReady ||
        parent.relationships.relTabbar.GetTabOrder("|") !== "");
    return isReady;
};

//Function to check if desired tab is selected
var isTabSelected = function(palceholderTabId) {
    return (tabbar.GetSelectedTab() === palceholderTabId);
};

setTimeout(hideTabs, 10);]]></method_code>
  <method_type>JavaScript</method_type>
  <name>pop_po_disable_tabs</name>
 </Item>
</AML>